﻿using AOC2021.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Linq;

namespace AOC2021.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class AdventOfCodeController : ControllerBase
    {
        private readonly ILogger<AdventOfCodeController> _logger;

        public AdventOfCodeController(ILogger<AdventOfCodeController> logger)
        {
            _logger = logger;
        }

        [HttpPost]
        [Consumes("text/plain")]
        [Route("day1")]
        public AOCResponse Day(AOCVersion version, [FromBody] string input)
        {
            AOCRequest request = new AOCRequest() { Input = input, Version = version };
            var splitRoute = this.ControllerContext.HttpContext.Request.Path.ToString().Split("/");
            string requestedRoute = splitRoute[splitRoute.Length - 1]; //Get the last endpoint value.
            return GetAOCDay(requestedRoute).ExecuteDay(request);
        }

        private AOCDay GetAOCDay(string route)
        {
            IAOCService day = null;
            var type = typeof(AOCDay);
            var types = AppDomain.CurrentDomain.GetAssemblies()
                .SelectMany(s => s.GetTypes())
                .Where(p => type.IsAssignableFrom(p) && !p.IsInterface && !p.IsAbstract);
            foreach (var x in types)
            {
                Console.WriteLine(x.Name.ToLower());
                if (x.Name.ToLower() == route.ToLower())
                {
                    day = (IAOCService)Activator.CreateInstance(x);
                }


            }
            return (AOCDay) day;
        }
    }
}
