﻿
using Microsoft.Extensions.Logging;

namespace AOC2021.Models
{
    public abstract class AOCDay : IAOCService
    {
        protected AOCRequest _request;
        protected ILogger<AOCDay> _logger;
        public AOCResponse ExecuteDay(AOCRequest request)
        {
            _request = request;
            switch (request.Version)
            {
                case AOCVersion.A:
                    return ExecutePartA();
                case AOCVersion.B:
                    return ExecutePartB();
            }
            return new AOCResponse() { Answer = "AOCDay failed to get a response", Status = false };
        }

        protected abstract AOCResponse ExecutePartA();
        protected abstract AOCResponse ExecutePartB();
    }
}
